// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Vehicles.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
/*	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
*/


	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP /*| CBRS_BORDER_ANY*/
		/*| CBRS_GRIPPER*/ | CBRS_TOOLTIPS/* | CBRS_FLYBY | CBRS_SIZE_DYNAMIC*/)/* ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME)*/)
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	toolbarImages.Create(29, 25, ILC_COLOR24, 6, 0);
	toolbarImagesHot.Create(29, 25, ILC_COLOR24, 6, 0);
	toolbarImagesDisabled.Create(29, 25, ILC_COLOR24, 6, 0);


	CreateToolbar();

	m_wndToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);

	m_wndToolBar.SetButtons(0,8);

	m_wndToolBar.SetSizes(CSize(29+7,25+6),CSize(29,25));

	m_wndToolBar.SetButtonInfo(0, ID_COMMAND_PLAY, TBSTYLE_BUTTON, 0);
	m_wndToolBar.SetButtonInfo(1, ID_COMMAND_STOP, TBSTYLE_BUTTON, 1);
	m_wndToolBar.SetButtonInfo(2, 0, TBSTYLE_SEP, 0);
	m_wndToolBar.SetButtonInfo(3, ID_LOG_SHOWLOG, TBSTYLE_BUTTON, 2);
	m_wndToolBar.SetButtonInfo(4, 0, TBSTYLE_SEP, 0);
	m_wndToolBar.SetButtonInfo(5, ID_COMMAND_ADDCAR, TBSTYLE_BUTTON, 3);
	m_wndToolBar.SetButtonInfo(6, ID_COMMAND_REMOVECAR, TBSTYLE_BUTTON, 4);
	m_wndToolBar.SetButtonInfo(7, ID_COMMAND_VIEWCARINFO, TBSTYLE_BUTTON, 5);


	//m_wndToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);


	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	//m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	//EnableDocking(CBRS_ALIGN_ANY);
	//DockControlBar(&m_wndToolBar);

	return 0;
}

void CMainFrame::CreateToolbar()
{
	CBitmap bmp;
	CBitmap bmpHot;
	CBitmap bmpDisabled;

	//bmp.LoadBitmap(IDB_BITMAP25);
	//bmpHot.LoadBitmap(IDB_BITMAP25);
	//bmpDisabled.LoadBitmap(IDB_BITMAP25);
	bmp.Attach (::LoadImage (::AfxFindResourceHandle(
		MAKEINTRESOURCE (IDB_TOOLBAR), RT_BITMAP),
		MAKEINTRESOURCE (IDB_TOOLBAR), IMAGE_BITMAP, 0, 0,
		(LR_DEFAULTSIZE | LR_CREATEDIBSECTION)));
	bmpHot.Attach (::LoadImage (::AfxFindResourceHandle(
		MAKEINTRESOURCE (IDB_TOOLBAR), RT_BITMAP),
		MAKEINTRESOURCE (IDB_TOOLBAR), IMAGE_BITMAP, 0, 0,
		(LR_DEFAULTSIZE | LR_CREATEDIBSECTION)));
	bmpDisabled.Attach (::LoadImage (::AfxFindResourceHandle(
		MAKEINTRESOURCE (IDB_TOOLBAR), RT_BITMAP),
		MAKEINTRESOURCE (IDB_TOOLBAR), IMAGE_BITMAP, 0, 0,
		(LR_DEFAULTSIZE | LR_CREATEDIBSECTION)));
	// figure out how many pixels there are in the bitmap
	BITMAP bmInfo;

	bmp.GetBitmap (&bmInfo);

	// add support for additional bit depths if you choose
	//VERIFY (bmInfo.bmBitsPixel == 24);
	//VERIFY (bmInfo.bmWidthBytes == (bmInfo.bmWidth * 3));

	UINT numPixels = bmInfo.bmHeight * bmInfo.bmWidth;

	// get a pointer to the pixels
	DIBSECTION  ds;
	DIBSECTION  dsHot;
	DIBSECTION  dsDisabled;

	bmp.GetObject (sizeof (DIBSECTION), &ds);
	RGBTRIPLE* pixels = (RGBTRIPLE*)(ds.dsBm.bmBits);

	bmpHot.GetObject (sizeof (DIBSECTION), &dsHot);
	RGBTRIPLE* pixelsHot =	(RGBTRIPLE*)(dsHot.dsBm.bmBits);

	bmpDisabled.GetObject (sizeof (DIBSECTION), &dsDisabled);
	RGBTRIPLE* pixelsDisabled =	(RGBTRIPLE*)(dsDisabled.dsBm.bmBits);


	// get the user's preferred	button color from the system
	COLORREF buttonColor = ::GetSysColor (COLOR_BTNFACE);
	COLORREF buttonHotColor = ::GetSysColor (COLOR_BTNHIGHLIGHT);
	COLORREF buttonDisableColor = ::GetSysColor (COLOR_BTNSHADOW);
	RGBTRIPLE userBackgroundColor = {GetBValue(buttonColor), GetGValue(buttonColor),GetRValue(buttonColor)};
	RGBTRIPLE userBackgroundHotColor = {GetBValue(buttonHotColor), GetGValue(buttonHotColor),GetRValue(buttonHotColor)};
	RGBTRIPLE userDisableColor = {GetBValue(buttonDisableColor), GetGValue(buttonDisableColor),GetRValue(buttonDisableColor)};

	for(int	i =	0; i < numPixels; i++)
	{
		if (pixels[i].rgbtBlue == 192
			&& pixels[i].rgbtGreen == 192
			&& pixels[i].rgbtRed ==	192)
		{
			pixels[i] =	userBackgroundColor;
		}

		if (pixelsHot[i].rgbtBlue == 192
			&& pixelsHot[i].rgbtGreen == 192
			&& pixelsHot[i].rgbtRed ==	192)
		{
			pixelsHot[i] =	userBackgroundHotColor;
		}

		if (pixelsDisabled[i].rgbtBlue == 192
			&& pixelsDisabled[i].rgbtGreen == 192
			&& pixelsDisabled[i].rgbtRed ==	192)
		{
			pixelsDisabled[i] =	userBackgroundColor;
		}
		else
		{
/*			int grey = (userBackgroundColor.rgbtBlue + userBackgroundColor.rgbtGreen + userBackgroundColor.rgbtRed)/3 + (abs(userBackgroundColor.rgbtBlue - pixelsDisabled[i].rgbtBlue) + 
				abs(userBackgroundColor.rgbtGreen - pixelsDisabled[i].rgbtGreen) + 
				abs(userBackgroundColor.rgbtRed - pixelsDisabled[i].rgbtRed))/3;
*/			
/*			int grey = (pixelsDisabled[i].rgbtBlue + 
				pixelsDisabled[i].rgbtGreen + 
				pixelsDisabled[i].rgbtRed)/2;
			pixelsDisabled[i].rgbtBlue = grey;
			pixelsDisabled[i].rgbtGreen = grey;
			pixelsDisabled[i].rgbtRed = grey;*/

			if(userDisableColor.rgbtRed + userDisableColor.rgbtGreen + userDisableColor.rgbtBlue > 
				pixelsDisabled[i].rgbtBlue + pixelsDisabled[i].rgbtGreen + pixelsDisabled[i].rgbtRed)
			{
				pixelsDisabled[i] = userDisableColor;
			}
			else
			{
				pixelsDisabled[i] = userBackgroundColor;
			}
		}
	}


	toolbarImages.Add(&bmp,RGB (0, 0, 0));
	toolbarImagesHot.Add(&bmpHot,RGB (0, 0, 0));
	toolbarImagesDisabled.Add(&bmpDisabled,RGB (0, 0, 0));

	m_wndToolBar.GetToolBarCtrl().SetImageList(&toolbarImages);
	m_wndToolBar.GetToolBarCtrl().SetHotImageList(&toolbarImagesHot);
	m_wndToolBar.GetToolBarCtrl().SetDisabledImageList(&toolbarImagesDisabled);
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

