#pragma once

#include "List"
#include "Vector"
#include "Automobile.h"
#include "Junction.h"

class CWorld
{
public:
	CBitmap map;

	std::vector<CAutomobile> automobiles;
	std::vector<CJunction> juncs;

	CBitmap juncBG[5];
	CBitmap juncTLGreen[5];
	CBitmap juncTLRed[5];
	CBitmap juncTLYellow[5];

	CBitmap carBMP[1][4][3][3];

	CWorld(void);
	~CWorld(void);

	void OnDraw(CDC *pDC); 
	void OnTimer();
	void Init(CString worldName);

	void LoadMap(CString mapName);
	void DrawMap(CDC *pDC);

	void LoadJuncs(CString juncsName);
	void DrawJuncsBG(CDC *pDC);
	void DrawJuncsTL(CDC *pDC);

	void LoadCars(CString carName);
	void DrawCars(CDC *pDC);
	void AddCars();

	void LoadBMP(CFile *file, CBitmap *bitmap);
	void LoadBitmapByName(CString fileName, CBitmap *bitmap);
	void DrawBitmap(CDC* pDC, CBitmap *bitmap, CPoint point);
	CSize GetBitmapSize(CBitmap *bitmap);
};
